
from .broadcast import Broadcast
from src.socketClient import Socket
import time
import config as cfg 



def run(data, server, broadcast, broadcastPort):

    b = Broadcast(broadcast=broadcast,broadcastPort=broadcastPort)

    while(len(b.onlineOracles) < cfg.numberOfOracles):
        print("\tWe need min  ",cfg.numberOfOracles," Oracles. Waiting for mor Oracle. we have now ",len(b.onlineOracles)," online Oracles")
        time.sleep(.5)


    print("\nnow we have min ",cfg.numberOfOracles,"Oracles. List of All Online Oracles ->\n \t\n",b.onlineOracles,"\n\n")
    worker = []
    for i in range(cfg.numberOfOracles):
        print(i,b.onlineOracles[i])
        worker.append(Socket("127.0.0.1",int(b.onlineOracles[i][1]),{"type":"user","oracle":i})) #_[0] 

    print("Done",worker)
    print("\n")
    time.sleep(1)

    worker[0].toSEND({
        "type":"init",
        "id":"test",
        "connectorIP":"127.0.0.1",
        "connectorPort":int(worker[0].port)+1,
        "path":"/", # TODO
        "server":"smarthome.agio360.com" # TODO
    })
    worker[1].toSEND({
        "type":"init",
        "id":"test",
        "connectorIP":"127.0.0.1",
        "connectorPort":int(worker[0].port)+1,
        "server":"smarthome.agio360.com"

    })
    worker[2].toSEND({
        "type":"init",
        "id":"test",
        "connectorIP":"127.0.0.1",
        "connectorPort":int(worker[0].port)+1,
        "server":"smarthome.agio360.com",
        "data":"GET ......"# TODO
    })

    